                       ---------------------------------
                       -- PERSISTENT DATABASE VERSION --
                       --   of GUESS THE ANIMAL       --
                       -- (c) Doug Edmunds                --
                       -- Revision 1.1  8/8/97        --
                       ---------------------------------
include get.e
include wildcard.e
constant 
    NODE_TYPE = 1,
       DESCRIPTION = 1,
       ANIMAL = 2,
    QUESTION = 2,
    WHEN_TRUE = 3,
    WHEN_FALSE = 4

constant
    TRUE = 1,
    FALSE = 0

constant 
    KEYBOARD = 0, 
    SCREEN = 1

constant 
    DB_NAME = "animal.dat",
    BACK_NAME = "animal.dbk"


object database, p, prev_p, prev_answer
integer db, data_changed
data_changed = FALSE

function Yes()  -- returns TRUE if the answer is yes
    object answer

    answer = '?'
    while answer = '?' do
        answer = gets(KEYBOARD)
        if length(answer) > 1 then
            if answer[1] = 'y' or answer[1] = 'Y' then
                answer = TRUE
            elsif answer[1] = 'n' or answer[1] = 'N' then
                answer = FALSE
            else 
                answer = '?'
            end if
        else
            answer = '?'   
        end if
        if answer = '?' then
            puts(SCREEN, "\nPlease answer y or n: ")
        end if
    end while
    return answer
end function

procedure Guess()  -- narrows it down to one animal
    while TRUE do
        if database[p][NODE_TYPE] = ANIMAL then
            return
        end if
        printf(SCREEN, "\n\t%s? ", {database[p][QUESTION]})
        prev_p = p
        if Yes() then
            p = database[p][WHEN_TRUE]
            prev_answer = WHEN_TRUE
        else 
            p = database[p][WHEN_FALSE]
            prev_answer = WHEN_FALSE 
        end if
    end while
end procedure

global procedure Animal()
-- updates database of animal information

    object new, new_question, correct, answer, response

    while TRUE do
        p = 1    
        printf(SCREEN, "%s\n", 
          {"\nThink of an animal. Hit <cr> when you are ready, q to quit"})
        answer = gets(KEYBOARD)
        if length(answer) > 1 then
            if upper(answer[1]) = 'Q' then
                return
            end if
        end if
        Guess()
        printf(SCREEN, "\n\tIs it %s? ", {database[p][QUESTION]})
        if not Yes() then
            puts(SCREEN, "\nI give up. What was it? ")
            response = '?'
            while response = '?' do 
              correct = gets(KEYBOARD)
              ? length(correct)
              if length(correct) >1 then  
                correct = correct[1..length(correct)-1]
                database = append(database, {ANIMAL, correct})
                new = length(database)
                response = ' ' 
              end if  
            end while

            response = '?'
            while response = '?' do
             
              printf(SCREEN, "\n%s%s%s%s\n", 
              {"Please give me a question that would distinguish ",
              database[p][QUESTION], " from ", correct})

              new_question = gets(KEYBOARD)
              if length(new_question) >1 then 
                new_question = new_question[1..length(new_question)-1]
                if new_question[length(new_question)] = '?' then
                  new_question = new_question[1..length(new_question)-1]
                end if
                response = ' ' 
              end if
            end while

            printf(SCREEN, "\nFor %s the answer would be: ", {correct})
            if Yes() then
                database = append(database, {DESCRIPTION, new_question, new, p})
            else
                database = append(database, {DESCRIPTION, new_question, p, new})
            end if
            database[prev_p][prev_answer] = length(database)
            data_changed = TRUE
        end if
    end while
end procedure

procedure Open_File()
   -- open database file on disk
sequence new_database
      --the next line starts a database if one is not found
      new_database = {{1,"Does it fly",2,3},{2,"an eagle"},{2,"a snake"}}

      db = open(DB_NAME, "r")
      if db = -1 then
        puts(1, "\nError opening data file\nIf this is your first use, just continue")
        puts(1, "\nContinue? ")
        if Yes() then 
          database = new_database
          db = open (DB_NAME,"w")
          print (db, database)
          close (db)
          db = open(DB_NAME,"r")
        else
           abort(1)
        end if
      end if 

      database = get (db)
      if database[1] != 0 then 
        puts(1, "\nError accessing data\n")
        abort(1)
      else
        database = database[2]
      end if   
      close (db)
end procedure

procedure Save_and_Close_File()
-- save the data to file for next run
if data_changed then 
   puts(1,"\n\tDatabase has changed. Save changes?")
   if Yes() then 
     system("copy " & DB_NAME & " " & BACK_NAME & " > NUL", 2)
     db = open(DB_NAME, "w")
     if db = -1 then
       system("copy " & BACK_NAME & " " & DB_NAME & " > NUL", 2)
       puts (1,"\nCan't save database - recover from backup file")
       abort(1)
     end if
     print (db, database)
     close (db)
   end if
end if 
end procedure

---main program starts here
printf(SCREEN, "%s\n", 
  {"\nPersistent Data Version of Animal.Ex Ver 1.1"})
Open_File()
Animal()  -- loop
Save_and_Close_File()

